package com.example.services.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.example.MyResult;
import com.example.api.R;
import com.example.entity.ContainerRegisterQuery;
import com.example.entity.OutCenter;
import com.example.services.IService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.jws.WebParam;
import javax.jws.WebService;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.concurrent.Semaphore;
import java.util.concurrent.TimeUnit;

import static com.example.services.impl.WebSocketServerContent.getRecMessage;

/**
 * Created by wangh on 2021/1/14-10:29。
 */
@WebService(
        targetNamespace = "http://service.example.com/",
        serviceName = "authorService",           //服务name名称
        portName = "authorPortName",
        endpointInterface = "com.example.services.IService")//指定发布webservcie的接口类，此类也需要接入@WebService注解
public class ServiceImpl implements IService {
    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    private static final Logger log = LoggerFactory.getLogger(ServiceImpl.class);

    public static String rfid;
    private static boolean m_GetInCenterStartSuccessful;
    private static boolean m_GetInCenterStopSuccessful;
//    private static boolean m_GetOutCenterStartSuccessful;
//    private static boolean m_GetOutCenterStopSuccessful;
//    private static boolean StartFlag = false;
    private static final Semaphore m_RecData = new Semaphore(1);
    private static final Semaphore m_RecstopData = new Semaphore(1);

    public boolean DealValidPack(String ValidData) {
        try {
            rfid = ValidData;
            System.out.println("RFID=" + rfid);
            if (!ValidData.isEmpty() || !ValidData.equals("")) {
//                m_RecData.release();
                switch (ValidData) {
                    case "101":
                        m_GetInCenterStartSuccessful = true;
                        break;
                    case "103":
                    case "105":
                        m_GetInCenterStartSuccessful = true;
                        rfid = "";
                        break;
                    case "102":
                    case "104":
                    case "106":
                        m_GetInCenterStopSuccessful = true;
                        break;
                    default:
                        m_GetInCenterStopSuccessful = true;
                        break;

                }
            }
        } catch (Exception ex) {
            return false;
        }
        return true;
    }

    //请求地址 http://localhost:9090/services/cpfinterface?wsdl
    @Override
    public R getScanInfoInCenterStart(
            String containerRegisterQuery,
            String pdaip,
            int functionID) {
        System.out.println("\n调用开始读参数为：" + "\npdaID=" + pdaip + "\nfunctionID=" + functionID + "\ncontainerRegisterQuery=" + containerRegisterQuery
                + "\t开始请求时间" + sdf.format(new Date()));
        ContainerRegisterQuery containerRegisterQuery1 = new ContainerRegisterQuery();
        containerRegisterQuery1.setContainerRegisterQuery(containerRegisterQuery);
        containerRegisterQuery1.setPdaip(pdaip);
        containerRegisterQuery1.setCommandCode(functionID);
        String json = JSONObject.toJSONString(containerRegisterQuery1);
        log.error("\n"+sdf.format(new Date())+"调用开始读参数为：" + "\npdaID=" + pdaip
                + "\nfunctionID=" + functionID + "\ncontainerRegisterQuery=" + containerRegisterQuery );
//        if(StartFlag){
//            return R.data(100, "向客户端发送消息失败，请先发送结束入库读指令在进行其他操作!");
//        }
        if (WebSocketServerContent.getSocket(pdaip, json)) {
//            StartFlag = true;
            try {
                Thread.sleep(3000);
                if (m_GetInCenterStartSuccessful) {
                    m_GetInCenterStartSuccessful = false;
                    System.out.println("\n开始读返回：成功" + "\t开始请求时间" + sdf.format(new Date()) );
                    log.error("\n开始读返回：200成功" + "\t开始请求时间" + sdf.format(new Date()) );
                    return R.data(200, "向客户端发送消息成功!");
                } else {
                    System.out.println("\n开始读返回：消息超时!");
                    log.error("\n开始读返回：201消息超时!");
                    return R.data(201, "向客户端发送消息成功，接收客户端消息超时!");
                }
            } catch (Exception ex) {
                log.error("\n开始读返回：100向客户端发送消息失败!");
                return R.data(100, "向客户端发送消息失败!");
            }
        } else {
            log.error("\n开始读返回：101失败!" + "\t返回时间" + sdf.format(new Date()));
            System.out.println("\n开始读返回：失败!" + "\t返回时间" + sdf.format(new Date()) );
            return R.data(101, "向客户端发送消息失败!");
        }


    }

    //停止读
    @Override
    public R getScanInfoInCenterStop(String containerRegisterQuery,
                                     String pdaip,
                                     int functionID) {
        log.error("\n"+sdf.format(new Date()) +"调用结束读参数为：" + "\tpdaID=" + pdaip
                + "\tfunctionID=" + functionID + "\ncontainerRegisterQuery=" + containerRegisterQuery);
        System.out.println("\n调用结束读参数为：" + "\tpdaID=" + pdaip + "\tfunctionID=" + functionID + "\ncontainerRegisterQuery=" + containerRegisterQuery);
        ContainerRegisterQuery containerRegisterQuery2 = new ContainerRegisterQuery();
        containerRegisterQuery2.setContainerRegisterQuery(containerRegisterQuery);
        containerRegisterQuery2.setPdaip(pdaip);
        containerRegisterQuery2.setCommandCode(functionID);
        String json = JSONObject.toJSONString(containerRegisterQuery2);
        if (WebSocketServerContent.getSocket(pdaip, json)) {
            try {
//
                if (m_GetInCenterStopSuccessful) {
                    m_GetInCenterStopSuccessful = false;
                    System.out.println("\n结束读返回：成功,返回数据=" + rfid);
                    if (functionID==106){
                        Thread.sleep(3000);
                        log.error("\n"+"请求时间" + sdf.format(new Date())+"\t结束读返回：成功,返回数据=" + rfid  );
                        return R.data(200, "向客户端发送消息成功!", rfid);
                    }else {
//                        StartFlag = false;
                        log.error("\n结束读返回：成功" + "\t开始请求时间" + sdf.format(new Date()));
                        return R.data(200, "向客户端发送消息成功!");

                    }
                } else {
                    System.out.println("\n结束读返回：消息超时!");
                    log.error("\n结束读返回：消息超时!");
                    return R.data(201, "向客户端发送消息成功，接收客户端消息超时!");
                }
            } catch (Exception ex) {
                log.error("\n结束读返回：100失败!" + "\t返回时间" + sdf.format(new Date()));
                return R.data(100, "向客户端发送消息失败!");
            }
        } else {
            System.out.println("\n结束读返回：失败!");
            log.error("\n结束读返回：101失败!" + "\t返回时间" + sdf.format(new Date()));
            return R.data(101, "向客户端发送消息失败!");
        }
    }


}
